function [ Udla eign L] = DLAMatrix( fea,gnd,options )

k1 = 2;
if isfield(options,'k1')
    k1 = options.k1;
end
m = zeros(size(fea,1),1)+1;
if isfield(options,'m')
    m = options.m;
end

k2 = 3;
if isfield(options,'k2')
    k2 = options.k2;
end

beta = 0.3;
if isfield(options,'beta')
    beta = options.beta;
end

[sampleNumber,dimension] = size(fea);
X = fea';
% build patch
F = zeros(sampleNumber,1+k1+k2);
Distant = Dist(fea,fea);
for LoopI = 1:sampleNumber
    idxsame = find(gnd == gnd(LoopI));
    idxsame(find(idxsame == LoopI)) = [];
    idxdiff = find(gnd ~= gnd(LoopI));
    if length(idxsame) >=k1
    samemat = Distant(LoopI,idxsame');
    [junk1 sidx] = sort(samemat);
    sameid = idxsame(sidx);
    else
        sameid = zeros(100,1);
    end
    if length(idxdiff) >=k2
    diffmat = Distant(LoopI,idxdiff');
    [junk2 didx] = sort(diffmat);
    diffid = idxdiff(didx);
    else
        diffid = zeros(100,1);
    end
    sameclass = sameid(1:k1);
    diffclass = diffid(1:k2);
    F(LoopI,:) = [LoopI,sameclass',diffclass'];
end


% assign omega value
% for j = 1:k1+k2
%     if j <= k1
%     omega(:,j) = 1;
%     else omega(:,j) = -beta;
%     end
% end
omega = ones(1,k1+k2);
omega(:,k1+1:k1+k2) = -beta;
omega = omega';
sumomega = sum(omega);
Li = [sumomega,-omega';-omega,diag(omega)];

% caculate L matrix
S = zeros(sampleNumber,k1+k2+1);
L = zeros(sampleNumber);
for o = 1:sampleNumber
    for p = 1:sampleNumber
        for q = 1:k1+k2+1
            if p == F(o,q)
                S(p,q) = 1;
            else 
                S(p,q) = 0;
            end
        end
    end
L = L+S*Li*S'*m(o);
end
%X = fea';
mat = X*L*X';
mat = (mat+mat')/2;
[V,D] = eig(mat);
eign = diag(D) ;
[eign,index] = sort(eign);
Udla = V(:,index(1:end));


end

